<?xml version="1.0" encoding="utf-8"?>
<doctrine-mapping xmlns="http://doctrine-project.org/schemas/orm/doctrine-mapping"
                  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                  xsi:schemaLocation="http://doctrine-project.org/schemas/orm/doctrine-mapping https://www.doctrine-project.org/schemas/orm/doctrine-mapping.xsd">
    <entity
            name="Smtm\AuthProvider\Context\Token\Domain\Token"
            table="auth_provider_token"
            repository-class="Smtm\AuthProvider\Context\Token\Infrastructure\Repository\TokenRepository"
            change-tracking-policy="DEFERRED_EXPLICIT"
    >
        <id name="id" type="integer" column="id">
            <generator strategy="IDENTITY"/>
        </id>
        <field name="uuid" column="uuid" type="string" length="36" nullable="false">
            <options>
                <option name="fixed"/>
            </options>
        </field>
        <many-to-one field="userClient" target-entity="Smtm\Auth\Context\UserClient\Domain\UserClient" fetch="LAZY">
            <join-columns>
                <join-column name="auth_user_client_id" referenced-column-name="id"/>
            </join-columns>
        </many-to-one>
        <many-to-one field="token" target-entity="Smtm\AuthConsumer\Context\Token\Domain\Token" fetch="LAZY">
            <join-columns>
                <join-column name="auth_consumer_token_id" referenced-column-name="id"/>
            </join-columns>
        </many-to-one>
        <field name="providerUuid" column="provider_uuid" type="string" length="36" nullable="false">
            <options>
                <option name="fixed"/>
            </options>
        </field>
        <field name="idToken" column="id_token" type="text" nullable="false"/>
        <field name="accessToken" column="access_token" type="text" nullable="false"/>
        <field name="refreshToken" column="refresh_token" type="text" nullable="true"/>
        <field name="expires" column="expires" type="datetime_immutable" nullable="false"/>
        <field name="refreshTokenExpires" column="refresh_token_expires" type="datetime_immutable" nullable="false"/>
        <field name="used" column="used" type="smallint" nullable="false"/>
        <field name="revoked" column="revoked" type="smallint" nullable="false"/>
        <field name="tokenType" column="token_type" type="string" length="255" nullable="true">
            <options>
                <option name="fixed"/>
            </options>
        </field>
        <field name="scope" column="r_scope" type="text" nullable="true"/>
        <field name="created" column="created" type="datetime_immutable" nullable="false"/>
        <field name="modified" column="modified" type="datetime" nullable="true"/>
        <unique-constraints>
            <unique-constraint name="idx_unq_auth_provider_token_uuid" columns="uuid"/>
            <unique-constraint name="idx_unq_auth_provider_token_access_token" columns="access_token"/>
        </unique-constraints>
        <indexes>
            <index name="idx_fk_auth_provider_token_id" columns="auth_provider_token_id"/>
        </indexes>
    </entity>
</doctrine-mapping>
